package anywheresoftware.b4j.max123.gifdecoder;

import java.io.*;
//import java.net.*; in caso si faccia uso dell'URL


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

import javafx.embed.swing.SwingFXUtils;
import javafx.scene.image.Image;
import javafx.scene.image.PixelFormat;
import javafx.scene.image.PixelReader;
import javafx.scene.shape.Rectangle;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

@BA.ActivityObject        // I need this ??????????
@ShortName("GifDecoder")
@Version(1.0f)
@Author("Andrew Graham (B4A), edited by Massimo Meli (B4J)")
@SuppressWarnings({"unused","rawtypes","null"})

public class GifDecoder
{
//private static final double version = 1.0f;
protected static final int STATUS_OK = 0;
protected static final int STATUS_FORMAT_ERROR = 1;
protected static final int STATUS_OPEN_ERROR = 2;
protected InputStream inStream;
protected int status;
protected int width;
protected int height;
protected boolean gctFlag;
protected int gctSize;

public GifDecoder() {}

/**
 * Returns the version number of this library.
 */
public double getVersion()
{
  return 1.0f;
}

protected int loopCount = 1;

protected int[] gct;

protected int[] lct;
protected int[] act;
protected int bgIndex;
protected int bgColor;
protected int lastBgColor;
protected int pixelAspect;
protected boolean lctFlag;
protected boolean interlace;
protected int lctSize;
protected int ix;
protected int iy;
protected int iw;
protected int ih;

protected Rectangle lastRect;
protected Image image;
protected Image bitmap;
protected Image lastImage;

protected byte[] block = new byte['?'];
protected int blockSize = 0;

protected int dispose = 0;

protected int lastDispose = 0;
protected boolean transparency = false;
protected int delay = 0;
protected int transIndex;
protected static final int MaxStackSize = 4096;
protected short[] prefix;
protected byte[] suffix;
protected byte[] pixelStack;
protected byte[] pixels;
protected int[] dest;

protected ArrayList frames;
protected int frameCount;

public void LIBRARY_DOC() {}

private class _GifFrame
{
  public Image image;
  public int delay;
  
	 public boolean transparency;
  public int dispose;
  
  public _GifFrame(Image im, int del, boolean tr, int disp)
  {
    this.image = im;
    this.delay = del;
    this.transparency = tr;
    this.dispose = disp;
  }
} 

/**
* Returns the delay time, in milliseconds, for the frame number specified.
* This time is the period for which the frame should be displayed before advancing
* to the next frame.
*/
public int Delay(int frame)
{
this.delay = -1;
if ((frame >= 0) && (frame < this.frameCount))
{
 this.delay = ((_GifFrame)this.frames.get(frame)).delay;
}
return this.delay;
}

/**
* Disposes of all the frame bitmaps of any presently loaded GIF file.
* This may be necessary for memory management purposes on a device.
*/
public void DisposeFrames()
{
BA.Log("DisposeFrames()"); 	
if ((this.frames != null) && (this.frames.size() > 0))
{
 for (int i = 0; i < this.frames.size(); i++)
 {
   //((_GifFrame)this.frames.get(i)).image.recycle();
   ((_GifFrame)this.frames.get(i)).image.cancel();
 }
}
this.frames = new ArrayList();
this.bitmap = null;
this.lastImage = null;
this.image = null;
this.frameCount = 0;
}

/**
* Returns a Bitmap containing the specified frame.
*/
public Image Frame(int frame)
{
Image im = null;
if ((frame >= 0) && (frame < this.frameCount))
{
 im = ((_GifFrame)this.frames.get(frame)).image;
}
return im;
}

/**
* Loads the GIF from the pathname specified and decodes the individual frames. 
*/
public void Load(String dir, String gifname)
throws Exception
{
BufferedInputStream is;
if (dir == "AssetsDir") {
// is = BA.applicationContext.getAssets().open(gifname.toLowerCase(BA.cul));
	 BA.Log("Load image from AssetsDir");   
	 is = new BufferedInputStream(new FileInputStream(new File(anywheresoftware.b4a.objects.streams.File.getDirAssets(), gifname.toLowerCase(BA.cul)))); 
} else {
  is = new BufferedInputStream(new FileInputStream(new File(dir, gifname)), 4096);
}

BA.Log("Read InputStream");
Read(is);
}

/**
* Saves a frame to to the file and path specified in the format specified.
* Note that a file extension is not automatically added and must be specified
* as part of the filename. The file formats are "J" for jpg and "P" for png.
* Anything else is saved as jpg. 
*/
public void SaveFrame(int frame, String dir, String filename, String format)
throws Exception
{
BufferedOutputStream os = new BufferedOutputStream(new FileOutputStream(new File(dir, filename), false));

Image img = ((_GifFrame)this.frames.get(frame)).image; 

//File outputFile = new File("C:/Images/");
BufferedImage bImage = SwingFXUtils.fromFXImage(img, null);
try {
	 if (format.toLowerCase().charAt(0) == 'p') {
    ImageIO.write(bImage, "png", os);
	 } else
		ImageIO.write(bImage, "jpg", os);	 
} catch (IOException e) {
 throw new RuntimeException(e);
}

os.flush();
os.close();
}

/**
* Returns the number of frames in the last GIF loaded. 
*/
public int getFrameCount()
{
return this.frameCount;
}

/**
* Returns the iteration count, if one was specified, in the last GIF loaded otherwise
* it returns 1. The iteration count specifies how many times the animation should be displayed.
* A count of 0 means repeat indefinitely.
*/
public int getLoopCount()
{
return this.loopCount;
}

/**
* Returns the height of each frame in the last GIF loaded.
*/
public int getFrameHeight()
{
return this.height;
}

/**
* Returns the width of each frame in the last GIF loaded.
*/
public int getFrameWidth()
{
return this.width;
}

//***************** DECODER *****************

protected int[] GetPixels(Image img)
{
//byte[] pixels = new byte[ (int) (bmp.getWidth() * bmp.getHeight())];
int[] pixels = new int[ (int) (img.getWidth() * img.getHeight())];
//byte[] pixels = new byte[(int) (bmp.getWidth() * bmp.getHeight() * 4)];

//bmp.getPixels(pixels, 0, bmp.getWidth(), 0, 0, bmp.getWidth(), bmp.getHeight()); // original

PixelReader pr = img.getPixelReader();

pr.getPixels(    // use PixelFormat.getByteBgraInstance() for bytes
       0,
       0,
       (int) img.getWidth(),
       (int) img.getHeight(),
       PixelFormat.getIntArgbInstance(),
       pixels,
       0,
       (int) img.getWidth()
);

return pixels;
}


protected byte[] integersToBytes(int[] values) throws IOException  // aggiunta io
{
 ByteArrayOutputStream baos = new ByteArrayOutputStream();
 DataOutputStream dos = new DataOutputStream(baos);
 for(int i=0; i < values.length; ++i)
 {
      dos.writeInt(values[i]);
 }

 return baos.toByteArray();
}

protected void SetPixels(int[] pixels) throws IOException
{
//this.bitmap = Bitmap.createBitmap(pixels, this.image.getWidth(), this.image.getHeight(), Bitmap.Config.ARGB_8888);  // original Android   

InputStream is = null;
is.read(integersToBytes(pixels));
this.bitmap = new Image(is, this.image.getWidth(), this.image.getHeight(),true,false);
}

protected void SetPixels() throws IOException
{
if (this.dest == null) {
 this.dest = new int[(int) (this.image.getWidth() * this.image.getHeight())];
}
  
if (this.lastDispose > 1)
{
 if (this.lastDispose == 3)
 {
   int n = this.frameCount - 2;
   if (n > 0)
   {
     this.lastImage = Frame(n - 1);
     this.dest = GetPixels(this.lastImage);
   }
 }
 
 if (this.lastDispose == 2)
 { 
   int c = 0;
   if (this.transparency)
   {
     c = 0;
   }
   else
   {
     c = this.lastBgColor;
   }
   for (int i = 0; i < this.dest.length; i++) {
     this.dest[i] = c;
   }
 }
 
}

int pass = 1;
int inc = 8;
int iline = 0;
for (int i = 0; i < this.ih; i++)
{
 int line = i;
 if (this.interlace)
 {
   if (iline >= this.ih)
   {
     pass++;
     switch (pass) {
     case 2: 
       iline = 4;
       break;
     case 3: 
       iline = 2;
       inc = 4;
       break;
     case 4: 
       iline = 1;
       inc = 2;
     }
        
   }
   line = iline;
   iline += inc;
 }
 line += this.iy;
 if (line < this.height)
 {
   int k = line * this.width;
   int dx = k + this.ix;
   int dlim = dx + this.iw;
   if (k + this.width < dlim)
   {
     dlim = k + this.width;
   }
   int sx = i * this.iw;
   while (dx < dlim)
   {
     int index = this.pixels[(sx++)] & 0xFF;
     int c = this.act[index];
     if (c != 0)
     {
       this.dest[dx] = c;
     }
     dx++;
   }
 }
}

SetPixels(this.dest);
}

protected void DecodeImageData()
{
int NullCode = -1;
int npix = this.iw * this.ih;
  

if ((this.pixels == null) || (this.pixels.length < npix))
{
 this.pixels = new byte[npix];
}
if (this.prefix == null)
 this.prefix = new short['?'];
if (this.suffix == null)
 this.suffix = new byte['?'];
if (this.pixelStack == null) {
 this.pixelStack = new byte['?'];
}
  
int data_size = Read();
int clear = 1 << data_size;
int end_of_information = clear + 1;
int available = clear + 2;
int old_code = NullCode;
int code_size = data_size + 1;
int code_mask = (1 << code_size) - 1;
for (int code = 0; code < clear; code++)
{
 this.prefix[code] = 0;
 this.suffix[code] = ((byte)code); }
int bi;
int pi;
int top; int first; int count; int bits; int datum = bits = count = first = top = pi = bi = 0;
for (int i = 0; i < npix;)
{
 if (top == 0)
 {
   if (bits < code_size)
   {

     if (count == 0)
     {

       count = ReadBlock();
       if (count <= 0)
         break;
       bi = 0;
     }
     datum += ((this.block[bi] & 0xFF) << bits);
     bits += 8;
     bi++;
     count--;
   }
   else
   {
     int code = datum & code_mask;
     datum >>= code_size;
     bits -= code_size;
     
     if ((code > available) || (code == end_of_information))
       break;
     if (code == clear)
     {
       code_size = data_size + 1;
       code_mask = (1 << code_size) - 1;
       available = clear + 2;
       old_code = NullCode;
     }
     else if (old_code == NullCode)
     {
       this.pixelStack[(top++)] = this.suffix[code];
       old_code = code;
       first = code;
     }
     else {
       int in_code = code;
       if (code == available)
       {
         this.pixelStack[(top++)] = ((byte)first);
         code = old_code;
       }
       while (code > clear)
       {
         this.pixelStack[(top++)] = this.suffix[code];
         code = this.prefix[code];
       }
       first = this.suffix[code] & 0xFF;
          
       if (available >= 4096)
         break;
       this.pixelStack[(top++)] = ((byte)first);
       this.prefix[available] = ((short)old_code);
       this.suffix[available] = ((byte)first);
       available++;
       if (((available & code_mask) == 0) && (available < 4096))
       {
         code_size++;
         code_mask += available;
       }
       old_code = in_code;
     }
   }
 } else { top--;
   this.pixels[(pi++)] = this.pixelStack[top];
   i++;
 } }
for (int i = pi; i < npix; i++)
{
 this.pixels[i] = 0;
}
}

protected boolean Error()
{
  return this.status != 0;
}


	protected void Init()
{
	 BA.Log("Init()"); 
  DisposeFrames();
  this.status = 0;
  this.frameCount = 0;
  this.frames = new ArrayList();
  this.gct = null;
  this.lct = null;
}

protected int Read(InputStream inStream)
  throws Exception
{
	 BA.Log("Read(InputStream inStream)");  
  Init();
  if (inStream != null)
  {
    this.inStream = inStream;
    ReadHeader();
    if (!Error())
    {
      ReadContents();
      if (this.frameCount < 0)
      {
        this.status = 1;
      }
    }
    inStream.close();
  }
  else {
    this.status = 2;
  }
  return this.status;
}


protected int Read()
{
	 BA.Log("Read()");  
  int curByte = 0;
  try
  {
    curByte = this.inStream.read();
  }
  catch (Exception e) {
    this.status = 1;
  }
  return curByte;
}


protected int ReadBlock()
{
	 BA.Log("ReadBlock()"); 	 
  this.blockSize = Read();
  int n = 0;
  if (this.blockSize > 0)
  {
    try
    {
      int count = 0;
      while (n < this.blockSize)
      {
        count = this.inStream.read(this.block, n, this.blockSize - n);
        if (count == -1)
          break;
        n += count;
      }
    }
    catch (Exception localException) {}
    

    if (n < this.blockSize)
    {
      this.status = 1;
    }
  }
  return n;
}


protected int[] ReadColorTable(int ncolors)
{
	 BA.Log("ReadColorTable(int ncolors)"); 
	 BA.Log("ncolors: " + ncolors); 
	 
  int nbytes = 3 * ncolors;
  int[] tab = (int[])null;
  byte[] c = new byte[nbytes];
  int n = 0;
  
  try
  {
    n = this.inStream.read(c, 0, c.length);
  }
  catch (Exception localException) {}

	 BA.Log("n: " + n);    
  
  if (n < nbytes)
  {
    this.status = 1;
    BA.Log("status: " + status); 
  }
  else {
//    tab = new int['?'];     // originale
    tab = new int[ncolors];
    int i = 0;
    int j = 0;
    while (i < ncolors)
    {
      BA.Log("i: " + i); 
      BA.Log("j: " + j); 
      int r = c[(j++)] & 0xFF;
      int g = c[(j++)] & 0xFF;
      int b = c[(j++)] & 0xFF;
      tab[(i++)] = (0xFF000000 | r << 16 | g << 8 | b);
      BA.Log("tab[" + (i-1) + "]: " + tab[i-1]); 
    }
  }
  
	 BA.Log("end");
	 
  return tab;
}


protected void ReadContents() throws IOException
{
	 BA.Log("ReadContents()");  	  
  boolean done = false;
  while ((!done) && (!Error()))
  {
    int code = Read();
    switch (code)
    {
    case 44: 
      ReadImage();
      break;
    
    case 33: 
      code = Read();
      switch (code) {
      case 249: 
        ReadGraphicControlExt();
        break;
      
      case 255: 
        ReadBlock();
        String app = "";
        for (int i = 0; i < 11; i++)
        {
          app = app + (char)this.block[i];
        }
        if (app.equals("NETSCAPE2.0"))
        {
          ReadNetscapeExt();
        } else
          Skip();
        break;
      
      default: 
        Skip();
      }
      
      break;
    
    case 59: 
      done = true;
      break;
    
    case 0: 
      break;
    
    default: 
      this.status = 1;
    }
    
  }
}


protected void ReadGraphicControlExt()
{
	 BA.Log("ReadGraphicControlExt()");  	 	  
  Read();
  int packed = Read();
  this.dispose = ((packed & 0x1C) >> 2);
  if (this.dispose == 0)
  {
    this.dispose = 1;
  }
  this.transparency = ((packed & 0x1) != 0);
  this.delay = (ReadShort() * 10);
  this.transIndex = Read();
  Read();
}

protected void ReadHeader()
{
	 BA.Log("ReadHeader()");  	  
  String id = "";
  for (int i = 0; i < 6; i++)
  {
    id = id + (char)Read();
  }
  if (!id.startsWith("GIF"))
  {
    this.status = 1;
    return;
  }
  
  ReadLSD();
  if ((this.gctFlag) && (!Error()))
  {
    this.gct = ReadColorTable(this.gctSize);
    this.bgColor = this.gct[this.bgIndex];
  }
}

@SuppressWarnings("unchecked")
	protected void ReadImage() throws IOException
{
	 BA.Log("ReadImage()");  	  
  this.ix = ReadShort();
  this.iy = ReadShort();
  this.iw = ReadShort();
  this.ih = ReadShort();
  
  int packed = Read();
  this.lctFlag = ((packed & 0x80) != 0);
  this.interlace = ((packed & 0x40) != 0);
  
  this.lctSize = (2 << (packed & 0x7));
  if (this.lctFlag)
  {
    this.lct = ReadColorTable(this.lctSize);
    this.act = this.lct;
  }
  else {
    this.act = this.gct;
    if (this.bgIndex == this.transIndex)
      this.bgColor = 0;
  }
  int save = 0;
  if (this.transparency)
  {
    save = this.act[this.transIndex];
    this.act[this.transIndex] = 0;
  }
  if (this.act == null)
  {
    this.status = 1;
  }
  if (Error())
    return;
  DecodeImageData();
  Skip();
  if (Error())
    return;
  this.frameCount += 1;
  
//  this.bitmap = Bitmap.createBitmap(this.width, this.height, Bitmap.Config.ARGB_8888);  // original Android   
  
  InputStream is = null;
  is.read(pixels);
  this.bitmap = new Image(is, this.width, this.height,true,false);
  
  this.image = this.bitmap;
  SetPixels();
  this.frames.add(new _GifFrame(this.bitmap, this.delay, this.transparency, this.dispose));
  if (this.transparency)
  {
    this.act[this.transIndex] = save;
  }
  ResetFrame();
}
  
protected void ReadLSD()
{
	 BA.Log("ReadLSD()");   
  this.width = ReadShort();
  this.height = ReadShort();
  
  int packed = Read();
  this.gctFlag = ((packed & 0x80) != 0);
  
  this.gctSize = (2 << (packed & 0x7));
  
  this.bgIndex = Read();
  this.pixelAspect = Read();
}

protected void ReadNetscapeExt()
{
	 BA.Log("ReadNetscapeExt()");  
	 
  do
  {
    ReadBlock();
    if (this.block[0] == 1)
    { 
      int b1 = this.block[1] & 0xFF;
      int b2 = this.block[2] & 0xFF;
      this.loopCount = (b2 << 8 | b1);
    }
  } while ((this.blockSize > 0) && (!Error()));
}

protected int ReadShort()
{
  return Read() | Read() << 8;
}

protected void ResetFrame()
{
	 BA.Log("ResetFrame()");  
  this.lastDispose = this.dispose;
  this.lastRect = new Rectangle(this.ix, this.iy, this.iw, this.ih);
  this.lastImage = this.image;
  this.lastBgColor = this.bgColor;
  this.transparency = false;
  this.delay = 0;
  this.lct = null;
}

protected void Skip()
{
	 BA.Log("Skip()");  
	 
  do
  {
    ReadBlock();
  } while ((this.blockSize > 0) && (!Error()));
}
  
}

